
/*
 *  Calc - Calculator that simple works
 *  -----------------------------------
 *  Copyright (c) 2013 Mario Wan Stadnik <wanstadnik*gmail.com>
 *
 *
 *  Changelog:
 *
 *  14/10/2013 - Jos Quintas - Removed unused and STATIC variables, code clean up, build opmization
 *  14/10/2013 - Qatan        - Added GTWVT features, fonts, full screen, icon, program info
 *  15/10/2013 - Qatan        - Fixed problem showing ****** and limiting size of numbers
 *
 */
             
#include 'hbgtinfo.ch'
#include 'inkey.ch'
#include 'box.ch'

////////////////////////////////////////////////////////////////////////////////
PROCEDURE  Calcula()  

    LOCAL  oCrtX_1

    SetColor("N/W")  


   oCrtX_1 := WvgCrt():New( , , { 06,25 }, {04,28 }, , .F. )   // cordenadas Ventana (tamao) 
   oCrtX_1:lModal      := .T.
   oCrtX_1:resizable   := .F.    // no se puede hacer ventana grande
   oCrtX_1:closable    := .T.   //.F.
   oCrtX_1:title       := "Calculator"  + space(10) + "[ Esc ] -> Exit "
   oCrtX_1:icon        := "Resource\calcula.ico"    

   oCrtX_1:Create()
   oCrtX_1:Show()

   SetColor("N/W")  
   CLS
   Calc()
   
   DO WHILE .T. 
      IF inkey() == K_ESC 
             EXIT 
      ENDIF 
   ENDDO 

   oCrtX_1:Destroy() 
 

   RETURN


PROCEDURE Calc()   

   LOCAL cD, cS, cSS, cB, cT
	LOCAL lAll, nKey, cKey
	LOCAL lNew  := .F.
	LOCAL lOver := .F.
	LOCAL lDoIt := .T.
   
   SETCURSOR( 0 )

   cD  := ''
   cS  := ''
   cSS := ''
   cB  := ''

   DO WHILE .T.
   
      Show( @lAll, @lOver, @lNew, @cD, @cS, @cSS )

      
      nKey := INKEY(0)
      cKey := IF( nKey == K_ENTER, '=',;
              IF( nKey == K_SPACE, '+',;
                  UPPER( CHR( nKey ) ) ) )
      
      IF lOver
         cKey := 'C'
         lOver := .F.
      ENDIF
      
      DO CASE
      CASE nKey == K_ESC
         EXIT

      CASE cKey $ '0123456789'
         IF lNew
            IF cSS != '='
               cB := cD
            ENDIF   
            cD := ''
            lNew := .F.
         ENDIF
         IF LEN( cD ) < IF( '.' $ cD, 16, 15 )
            cD += cKey
            lDoit := .T.
         ENDIF

      CASE cKey $ '.,'
         IF lNew
            cD := ''
            lNew := .F.
         ENDIF
         IF ! '.' $ cD
            cD += '.'
         ENDIF

      CASE nKey == K_BS .OR. nKey == K_DEL
         IF !lNew
            IF LEN( cD ) > IF( '.' $ cD, 1, 0 )
               cD := LEFT( cD, LEN( cD ) - 1 )
               IF RIGHT( cD, 1 ) == '.'
                  cD := LEFT( cD, LEN( cD ) - 1 )
               ENDIF
            ENDIF
         ENDIF

      CASE cKey $ '+-/*='
         IF lDoit .OR. cKey == '='
            lDoit := .F.
            cT := cD
            IF cS == '+'
               cD := LTRIM( STR( VAL(cB) + VAL(cD), 40, 14 ) )
            ELSEIF cS == '-'
               cD := LTRIM( STR( IF( cSS = cS, VAL(cB) - VAL(cD), VAL(cD) - VAL(cB) ), 40, 14 ) )
            ELSEIF cS == '*'
               cD := LTRIM( STR( VAL(cB) * VAL(cD), 40, 14 ) )
            ELSEIF cS == '/'
               cD := LTRIM( STR( IF( cSS == cS, VAL(cB) / VAL(cD), VAL(cD) / VAL(cB) ), 40, 14 ) )
            ENDIF                           // 1234567890123456     
            IF cSS != '='                   // 0.12345678901234     
               IF cKey == '='
                  lDoit := .F.                                                        
                  cB := cT                                                             
               ELSE
                  cB := cD
               ENDIF
            ENDIF
         ELSE
            cB := cD
         ENDIF
         cSS := IF( EMPTY( cB ) .AND. EMPTY( cD ), '', cKey )
         lNew := .T.
         IF cKey $ '+-/*'
            cS := cKey
         ENDIF

      CASE cKey == 'C' .OR. lOver
         cD  := ''
         cS  := ''
         cSS := ''
         cB  := ''

      ENDCASE
   ENDDO
RETURN



////////////////////////////////////////////////////////////////////////////////
PROCEDURE Show( lAll, lOver, lNew, cD, cS, cSS )
   LOCAL nL1, nC1, nL2, nC2

   hb_Default( @lAll, .T. )
   hb_Default( @nL1, MAXROW()-3 )
   hb_Default( @nC1, 1 )
   hb_Default( @nL2, MAXROW()-1 )
   hb_Default( @nC2, 27 )

   IF lAll
      DISPBOX( nL1, nC1, nL2, nC2, CHR(219) + CHR(223) + CHR(219) + CHR(219) + CHR(219) + CHR(220) + CHR(219) + CHR(219) + CHR(32), 'N+/N' )
      lAll := .F.
   ENDIF
              
   IF VAL( cD ) > 999999999999999 .OR. VAL( cD ) < -99999999999999
      lOver := .T.
      lAll := .T.
      @ nL1+1, nC1+1 SAY PADC( "Overflow", 25 ) COLOR 'R+/N'
      DO WHILE UPPER( CHR( INKEY(0) ) ) <> 'C'
         IF LASTKEY() == K_ESC
            EXIT
         ENDIF
      ENDDO
      KEYBOARD 'C'
      RETURN 
   ENDIF

   @ nL1+1, 5  SAY PADL( FixIt( cD, lNew ), 18 ) COLOR 'GR+/N'
   IF lNew
      @ nL1+1, 25 SAY PADR( cSS, 2 )             COLOR 'GR+/N'
	ELSE
      @ nL1+1, 25 SAY PADR( cS, 2 )              COLOR 'GR+/N'
   ENDIF
	
RETURN



////////////////////////////////////////////////////////////////////////////////
FUNCTION FixIt( cDisplay, lNew )

   cDisplay := IF( '.' $ cDisplay, cDisplay, cDisplay + '.' )
   cDisplay := IF( LEFT( cDisplay, 1 ) == '.', '0' + cDisplay, cDisplay )     // Fixing the "0."
   cDisplay := LEFT( cDisplay, 16 )                                           // Eliminating extra numbers

   DO WHILE LEFT( cDisplay, 1 ) == '0'                                        // Cleanning zeroes on the left
      IF SUBSTR( cDisplay, 2, 1 ) == '.'
         EXIT
      ENDIF
      cDisplay := SUBSTR( cDisplay, 2 )
   ENDDO

   IF lNew
      DO WHILE RIGHT( SUBSTR( cDisplay, AT( '.', cDisplay ) + 1 ), 1 ) == '0' // Cleanning zeroes on the right
         cDisplay := SUBSTR( cDisplay, 1, LEN( cDisplay ) - 1 )
      ENDDO
   ENDIF

RETURN cDisplay


